/* This code was very significantly modified from the circle.c file from
   the Hearn and Baker website and therefore might vaguely ressemble that
   code in format.
*/
#include <visenv.h>

//Function Prototypes//
void CirclePlot(Point center, long x, long y, Pixel color, Image *image);
void CirclePlotBorder(Point center, long x, long y, Pixel color, Image *image);

//Function Definition
void Circle(Point center, long R, Pixel color, Image *image){

  long x = 0;
  long y = (-1)*R;
  float p = 1.2 - R;
    
  //plot first set of 8 points
  CirclePlot(center, x, y, color, image);
  
  while (abs(x) <= abs(y)) {  //while in 6th octant (half of the third quadrant)    
    x--;
    
    p = x*x + (y + 0.5) * (y + 0.5) - R*R;  //error equation
    
    if (p > 0) {     //outside the circle
      y++;           //pick "inside" pixel
    }
    
    //plot 8 points each time
    CirclePlot(center, x, y, color, image);   
  }  

} //end of Circle


void CircleBorder(Point center, long R, Pixel color, Image *image){

  long x = 0;
  long y = (-1)*R;
  float p = 1.2 - R;
   
  //plot first set of 8 points
  CirclePlotBorder(center, x, y, color, image);
  
  while (abs(x) <= abs(y)) {  //while in 6th octant (half of the third quadrant)
    
    x--;
    
    p = x*x + (y + 0.5) * (y + 0.5) - R*R;  //error equation
    
    if (p > 0) {     //outside the circle
      y++;           //pick "inside" pixel
    }
    
    //plot 8 points each time
    CirclePlotBorder(center, x, y, color, image);   
  }  
  
} //end of CircleBorder


void CirclePlot (Point center, long x, long y, Pixel color, Image *image) {

  Point pt1start, pt1end, pt2start, pt2end, pt3start, pt3end, pt4start, pt4end;

  pt1start[0] = center[0] - x;
  pt1start[1] = center[1] + y;
  pt1end[0] = center[0] + x;
  pt1end[1] = center[1] + y;

  pt2start[0] = center[0] - x;
  pt2start[1] = center[1] - y - 1;
  pt2end[0] = center[0] + x;
  pt2end[1] = center[1] - y - 1;

  pt3start[0] = center[0] - y;
  pt3start[1] = center[1] + x;
  pt3end[0] = center[0] + y;
  pt3end[1] = center[1] + x;

  pt4start[0] = center[0] - y;
  pt4start[1] = center[1] - x - 1;
  pt4end[0] = center[0] + y;
  pt4end[1] = center[1] - x - 1;
  
  Line(pt1start, pt1end, color, image);
  Line(pt2start, pt2end, color, image);
  Line(pt3start, pt3end, color, image);
  Line(pt4start, pt4end, color, image);

}  //end CirclePlotFill


void CirclePlotBorder (Point center, long x, long y, Pixel color, Image *image) {

  PlotPixel(center[0] + x,     center[1] + y, color, image);
  PlotPixel(center[0] - x - 1, center[1] + y, color, image);
  PlotPixel(center[0] + x,     center[1] - y - 1, color, image);
  PlotPixel(center[0] - x - 1, center[1] - y - 1, color, image);
  PlotPixel(center[0] + y,     center[1] + x, color, image);
  PlotPixel(center[0] - y - 1, center[1] + x, color, image);
  PlotPixel(center[0] + y,     center[1] - x - 1, color, image);
  PlotPixel(center[0] - y - 1, center[1] - x - 1, color, image);
  
}  //end CirclePlot
