// images.c by Jiwon Shin
// last modified: June 26, 2003

#include <visenv.h>

// This function resizes the input image to the specified size
void resizeIm(Image *input, int cols, int rows) {

  Image im;
  double dx, dy, col, row, cCol, cRow, dc, dr;
  int i, cLoc, loc1, loc2;

  printf("Cols: %d Rows:%d\n",cols,rows);

  im.cols = cols;
  im.rows = rows;
  im.imagesize = im.rows * im.cols;

  if(input->color||input->chroma){
  im.image = (Pixel *)malloc(sizeof(Pixel)*im.imagesize);

  dx = (double)input->cols/(double)cols;
  dy = (double)input->rows/(double)rows;

  for(i=0; i<im.imagesize; i++) {
    col = (i%im.cols + .5)*dx;
    row = (i/im.cols + .5)*dy;
    cCol = (int)col + .5;
    cRow = (int)row + .5;
    dc = col - cCol;
    dr = row - cRow;
    if(dc < 0) {
      if(dr < 0) {
	cLoc = (int)row*input->cols+(int)col;
	loc1 = col < 0.5 ? cLoc : cLoc-1;
	loc2 = row < 0.5 ? cLoc : cLoc-input->cols;
	im.image[i].r = (((double)input->image[cLoc].r*(1+dc) -
			  (double)input->image[loc1].r*dc)/2 +
			 ((double)input->image[cLoc].r*(1+dr) - 
			  (double)input->image[loc2].r*dr)/2) +.5;
	im.image[i].g = (((double)input->image[cLoc].g*(1+dc) -
			  (double)input->image[loc1].g*dc)/2 +
			 ((double)input->image[cLoc].g*(1+dr) - 
			  (double)input->image[loc2].g*dr)/2) +.5;
	im.image[i].b = (((double)input->image[cLoc].b*(1+dc) -
			  (double)input->image[loc1].b*dc)/2 +
			 ((double)input->image[cLoc].b*(1+dr) - 
			  (double)input->image[loc2].b*dr)/2) +.5;
      }
      else {
	cLoc = (int)row*input->cols+(int)col;
	loc1 = col < 0.5 ? cLoc : cLoc-1;
	loc2 = row >= input->rows - 0.5 ? cLoc : cLoc+input->cols;
	im.image[i].r = (((double)input->image[cLoc].r*(1+dc) -
			  (double)input->image[loc1].r*dc)/2 +
			 ((double)input->image[cLoc].r*(1-dr) + 
			  (double)input->image[loc2].r*dr)/2) +.5;
	im.image[i].g = (((double)input->image[cLoc].g*(1+dc) -
			  (double)input->image[loc1].g*dc)/2 +
			 ((double)input->image[cLoc].g*(1-dr) + 
			  (double)input->image[loc2].g*dr)/2) +.5;
	im.image[i].b = (((double)input->image[cLoc].b*(1+dc) -
			  (double)input->image[loc1].b*dc)/2 +
			 ((double)input->image[cLoc].b*(1-dr) + 
			  (double)input->image[loc2].b*dr)/2) +.5;
      }
    }
    else {
      if(dr < 0) {
	cLoc = (int)row*input->cols+(int)col;
	loc1 = col >= input->cols - 0.5 ? cLoc : cLoc+1;
	loc2 = row < 0.5 ? cLoc : cLoc-input->cols;
	im.image[i].r = (((double)input->image[cLoc].r*(1-dc) +
			  (double)input->image[loc1].r*dc)/2 +
			 ((double)input->image[cLoc].r*(1+dr) - 
			  (double)input->image[loc2].r*dr)/2) +.5;
	im.image[i].g = (((double)input->image[cLoc].g*(1-dc) +
			  (double)input->image[loc1].g*dc)/2 +
			 ((double)input->image[cLoc].g*(1+dr) - 
			  (double)input->image[loc2].g*dr)/2) +.5;
	im.image[i].b = (((double)input->image[cLoc].b*(1-dc) +
			  (double)input->image[loc1].b*dc)/2 +
			 ((double)input->image[cLoc].b*(1+dr) - 
			  (double)input->image[loc2].b*dr)/2) +.5;
      }
      else {
	cLoc = (int)row*input->cols+(int)col;
	loc1 = col >= input->cols - 0.5 ? cLoc : cLoc+1;
	loc2 = row >= input->rows - 0.5 ? cLoc : cLoc+input->cols;
	im.image[i].r = (((double)input->image[cLoc].r*(1-dc) +
			  (double)input->image[loc1].r*dc)/2 +
			 ((double)input->image[cLoc].r*(1-dr) + 
			  (double)input->image[loc2].r*dr)/2) +.5;
	im.image[i].g = (((double)input->image[cLoc].g*(1-dc) +
			  (double)input->image[loc1].g*dc)/2 +
			 ((double)input->image[cLoc].g*(1-dr) + 
			  (double)input->image[loc2].g*dr)/2) +.5;
	im.image[i].b = (((double)input->image[cLoc].b*(1-dc) +
			  (double)input->image[loc1].b*dc)/2 +
			 ((double)input->image[cLoc].b*(1-dr) + 
			  (double)input->image[loc2].b*dr)/2) +.5;
      }
    }
  }

  input->cols=im.cols;
  input->rows=im.rows;
  input->imagesize=im.imagesize;

  free(input->image);
  input->image=im.image;
  }  
  else {
    im.gimage = (unsigned char *)malloc(sizeof(unsigned char)*im.imagesize);

    dx = (double)input->cols/(double)cols;
    dy = (double)input->rows/(double)rows;
    
    for(i=0; i<im.imagesize; i++) {
      col = (i%im.cols + .5)*dx;
      row = (i/im.cols + .5)*dy;
      cCol = (int)col + .5;
      cRow = (int)row + .5;
      dc = col - cCol;
      dr = row - cRow;
      if(dc < 0) {
	if(dr < 0) {
	  cLoc = (int)row*input->cols+(int)col;
	  loc1 = col < 0.5 ? cLoc : cLoc-1;
	  loc2 = row < 0.5 ? cLoc : cLoc-input->cols;
	  im.gimage[i] = (((double)input->gimage[cLoc]*(1+dc) -
			    (double)input->gimage[loc1]*dc)/2 +
			   ((double)input->gimage[cLoc]*(1+dr) - 
			    (double)input->gimage[loc2]*dr)/2) +.5;
      }
      else {
	cLoc = (int)row*input->cols+(int)col;
	loc1 = col < 0.5 ? cLoc : cLoc-1;
	loc2 = row >= input->rows - 0.5 ? cLoc : cLoc+input->cols;
	im.gimage[i] = (((double)input->gimage[cLoc]*(1+dc) -
			  (double)input->gimage[loc1]*dc)/2 +
			 ((double)input->gimage[cLoc]*(1-dr) + 
			  (double)input->gimage[loc2]*dr)/2) +.5;
      }
    }
    else {
      if(dr < 0) {
	cLoc = (int)row*input->cols+(int)col;
	loc1 = col >= input->cols - 0.5 ? cLoc : cLoc+1;
	loc2 = row < 0.5 ? cLoc : cLoc-input->cols;
	im.gimage[i] = (((double)input->gimage[cLoc]*(1-dc) +
			  (double)input->gimage[loc1]*dc)/2 +
			 ((double)input->gimage[cLoc]*(1+dr) - 
			  (double)input->gimage[loc2]*dr)/2) +.5;
      }
      else {
	cLoc = (int)row*input->cols+(int)col;
	loc1 = col >= input->cols - 0.5 ? cLoc : cLoc+1;
	loc2 = row >= input->rows - 0.5 ? cLoc : cLoc+input->cols;
	im.gimage[i] = (((double)input->gimage[cLoc]*(1-dc) +
			  (double)input->gimage[loc1]*dc)/2 +
			 ((double)input->gimage[cLoc]*(1-dr) + 
			  (double)input->gimage[loc2]*dr)/2) +.5;
      }
    }
  }

  input->cols=im.cols;
  input->rows=im.rows;
  input->imagesize=im.imagesize;

  free(input->gimage);
  input->gimage=im.gimage;
  }  

} // end resizeIm

//This function crops the input image
/* converted by fritz to use pointers 9/29*/
void cropIm(Image *input, int border) {

  void * temp;
  int i,imagesize;
  imagesize=(input->cols-border*2)*(input->rows-border*2);

  if(input->color||input->chroma){
    temp = (Pixel *)malloc(sizeof(Pixel)*imagesize);
  }else{
    temp = (void *)malloc(sizeof(unsigned char)*imagesize);
  }

  for(i=0; i<imagesize; i++){
    if(input->color||input->chroma){
      ((Pixel *)temp)[i] = input->image[(i/(input->cols-border*2)+border)*input->cols+i%(input->cols-border*2)+border];
    }else{
      ((unsigned char *)temp)[i] = input->gimage[(i/(input->cols-border*2)+border)*input->cols+i%(input->cols-border*2)+border];    
    } 
  }

  input->cols=input->cols-border*2;
  input->rows=input->rows-border*2;
  input->imagesize=imagesize;

  if(input->color||input->chroma){
    free(input->image);
    input->image=(Pixel *)temp;
  }else{
    free(input->gimage);
    input->gimage=(unsigned char *)temp;
  }
  
} // end cropIm

void cropXYIm(Image *input, int xborder, int yborder) {

  void * temp;
  int i,imagesize;
  imagesize=(input->cols-xborder*2)*(input->rows-yborder*2);

  if(input->color||input->chroma){
    temp = (Pixel *)malloc(sizeof(Pixel)*imagesize);
  }else{
    temp = (void *)malloc(sizeof(unsigned char)*imagesize);
  }

  for(i=0; i<imagesize; i++){
    if(input->color||input->chroma){
      ((Pixel *)temp)[i] = input->image[(i/(input->cols-xborder*2)+yborder)*input->cols+i%(input->cols-xborder*2)+xborder];
    }else{
      ((unsigned char *)temp)[i] = input->gimage[(i/(input->cols-xborder*2)+yborder)*input->cols+i%(input->cols-xborder*2)+yborder];    
    } 
  }

  input->cols=input->cols-xborder*2;
  input->rows=input->rows-yborder*2;
  input->imagesize=imagesize;

  if(input->color||input->chroma){
    free(input->image);
    input->image=(Pixel *)temp;
  }else{
    free(input->gimage);
    input->gimage=(unsigned char *)temp;
  }
  
} // end cropIm


void cropArbIm(Image *input, int x1, int x2, int y1, int y2) {

  void * temp;
  int i,imagesize,j,k=0;
  imagesize=(x2-x1)*(y2-y1);
  printf("X2: %d X1: %d Y2: %d Y1: %d Size: %d\n",x2,x1,y2,y1,imagesize);
  if(input->color||input->chroma){
    temp = (Pixel *)malloc(sizeof(Pixel)*imagesize);
  }else{
    temp = (void *)malloc(sizeof(unsigned char)*imagesize);
  }

    for(j=y1; j<y2; j++){
      for(i=x1; i<x2; i++,k++){
      if(input->color||input->chroma){
	((Pixel *)temp)[k] = input->image[j*input->cols+i];
      }else{
	((unsigned char *)temp)[k] = input->gimage[j*input->cols+i];
      } 
    }
  }

  input->cols=x2-x1;
  input->rows=y2-y1;
  input->imagesize=imagesize;

  if(input->color||input->chroma){
    free(input->image);
    input->image=(Pixel *)temp;
  }else{
    free(input->gimage);
    input->gimage=(unsigned char *)temp;
  }
  
} // end cropIm

/*
void cropArbIm(Image *input, int x1, int x2, int y1, int y2) {

  void * temp;
  int i,imagesize;
  imagesize=(input->cols-x1-x2)*(input->rows-y1-y2);

  if(input->color||input->chroma){
    temp = (Pixel *)malloc(sizeof(Pixel)*imagesize);
  }else{
    temp = (void *)malloc(sizeof(unsigned char)*imagesize);
  }

  for(i=0; i<imagesize; i++){
    if(input->color||input->chroma){
      ((Pixel *)temp)[i] = input->image[(i/(input->cols-x1-x2)+y1)
					*input->cols+i%(input->cols-x1-x2)+x1];
    }else{
      ((unsigned char *)temp)[i] = input->gimage[(i/(input->cols-x1-x2)+y1)
						 *input->cols+i%(input->cols-x1-x2)+y1]; 
    } 
  }

  input->cols=input->cols-x1-x2;
  input->rows=input->rows-y1-y2;
  input->imagesize=imagesize;

  if(input->color||input->chroma){
    free(input->image);
    input->image=(Pixel *)temp;
  }else{
    free(input->gimage);
    input->gimage=(unsigned char *)temp;
  }
  
  } */ // end cropIm

//This function applies 5x5 Gaussian filter to input image
void gaussianIm(Image *input) {

  Image temp;
  long i,j,k,l,loc;
  float gaussian[5][5] = {{1,2,4,2,1},
			  {2,4,6,4,2},
			  {4,6,10,6,4},
			  {2,4,6,2,1},
			  {1,2,4,2,1}};
  float dr,dg,db;
  
  if(input->color||input->chroma){
    temp.image = (Pixel *)calloc(input->imagesize,sizeof(Pixel));
  }else{
    temp.gimage = calloc(input->imagesize,sizeof(unsigned char));
  }

  if(input->color||input->chroma){
    for(i=2; i<input->rows-2; i++){
      for(j=2; j<input->cols-2; j++){
	loc=i*input->cols+j;
	dr=dg=db=0.0;
	for(k=-2; k<=2; k++) {
	  for(l=-2; l<=2; l++) {
	    //printf("i: %d j: %d k:%d l: %d\n",i,j,k,l);
	    //exit(0);
	    dr+=gaussian[k+2][l+2]*input->image[(i+k)*input->cols+(j+l)].r;
	    dg+=gaussian[k+2][l+2]*input->image[(i+k)*input->cols+(j+l)].g;
	    db+=gaussian[k+2][l+2]*input->image[(i+k)*input->cols+(j+l)].b;
	  }
	} 
	temp.image[loc].r=(unsigned char)(dr/86);
	temp.image[loc].g=(unsigned char)(dg/86);
	temp.image[loc].b=(unsigned char)(db/86);	
      }
    }
  }
  else{
    for(i=2; i<input->rows-2; i++){
      for(j=2; j<input->cols-2; j++){
	loc=i*input->cols+j;
	dr=0.0;
	for(k=-2; k<=2; k++) {
	  for(l=-2; l<=2; l++) {
	    dr+=gaussian[k+2][l+2]*input->gimage[(i+k)*input->cols+(j+l)];
	  }
	} 
	temp.gimage[loc]=(unsigned char)(dr/86);
      }
    }
  }

  if(input->color||input->chroma){
    free(input->image);
    input->image=temp.image;
  }else{
    free(input->gimage);
    input->gimage=temp.gimage;
  }
  
} // end gaussianIm

void addBorderIm(Image *input, int border, Pixel color) {

  void * temp;
  int loc,i,j,k,imagesize;
  imagesize=(input->cols+border*2)*(input->rows+border*2);

  if(input->color||input->chroma){
    temp = (Pixel *)malloc(sizeof(Pixel)*imagesize);
  }else{
    temp = (void *)malloc(sizeof(unsigned char)*imagesize);
  }

  for(j=0; j<input->rows+border*2; j++){
    for(k=0; k<input->cols+border*2; k++) {
      loc=j*(input->cols+border*2)+k;
      i=(j-border)*input->cols+(k-border);
      if(input->color||input->chroma){
	if(j>=border&&j<input->rows+border && k>=border&&k<input->cols+border) {
	  ((Pixel *)temp)[loc] = input->image[i];
	}else {
	  ((Pixel *)temp)[loc] = color;
	}
      }else{
	if(j>=border&&j<input->rows+border && k>=border&&k<input->cols+border) {
	  ((unsigned char *)temp)[loc] = input->gimage[i];
	}else {
	  ((unsigned char *)temp)[loc] = color.r;
	}
      } 
    }
  }

  input->cols=input->cols+border*2;
  input->rows=input->rows+border*2;
  input->imagesize=imagesize;

  if(input->color||input->chroma){
    free(input->image);
    input->image=(Pixel *)temp;
  }else{
    free(input->gimage);
    input->gimage=(unsigned char *)temp;
  }
  
}


//This function returns a copy of the input image
Image copyIm(Image *input) {

  Image im;
  int i;
  
  im.cols = input->cols;
  im.rows = input->rows;
  im.imagesize = input->imagesize;
  im.image = (Pixel *)malloc(sizeof(Pixel)*im.imagesize);
  
  for(i=0; i<im.imagesize; i++)
    im.image[i] = input->image[i];
  
  return im;
} // end copyIm

//This function returns a copy of the input image
Image *newCopyIm(Image *input) {

  Image *im;
  int i;
  
  im=(Image *)malloc(sizeof(Image));
  im->cols = input->cols;
  im->rows = input->rows;
  im->imagesize = input->imagesize;
  im->color = input->color;
  im->chroma= input->chroma;
  im->image = (Pixel *)malloc(sizeof(Pixel)*im->imagesize);
  
  for(i=0; i<im->imagesize; i++)
    im->image[i] = input->image[i];
  
  return im;
} // end copyIm


//This function creates chromaticity image.
Image *chromaticityIm(Image *input) {

  Image *im = (Image *)malloc(sizeof(Image));
  double sum;
  int i;

  im->cols = input->cols;
  im->rows = input->rows;
  im->imagesize = input->imagesize;
  im->image = (Pixel *)malloc(sizeof(Pixel)*im->imagesize);
  im->chroma=true;
  im->color=true;
  for(i=0; i<im->imagesize; i++) {
    sum = input->image[i].r + input->image[i].g + input->image[i].b;
    if(sum == 0.0) sum = 1.0;
    im->image[i].r = (unsigned char)((double)input->image[i].r/sum * 255 + .5);
    im->image[i].g = (unsigned char)((double)input->image[i].g/sum * 255 + .5);
    im->image[i].b = (unsigned char)((double)input->image[i].b/sum * 255 + .5);
  }
  
  return im;  
} // end chromaticityIm

//This function recreates the input image in grey-scale
Image *greyScaleIm(Image *input) {

  Image *im=(Image *)malloc(sizeof(Image));
  double sum;
  int i;
  
  im->cols = input->cols;
  im->rows = input->rows;
  im->imagesize = input->imagesize;
  im->color=false;
  im->chroma=false;
  im->gimage = (unsigned char *)malloc(sizeof(unsigned char)*im->imagesize);
  
  for(i=0; i<im->imagesize; i++) {
    // modified to mimic ppmtopgm
    sum = (.299)*(double)input->image[i].r + (.587)*(double)input->image[i].g + 
      (.114)*(double)input->image[i].b;
    //    sum /= 3.0;
    im->gimage[i] = (unsigned char)(sum + .5);    
  }
  
  return im;
} // end greyScaleIm

//This function creates gradient image
Image *gradientIm(Image *input) {
  
  Image *im = (Image *)malloc(sizeof(Image));
  float gmap[3][3] = {{1,2,1},{0,0,0},{-1,-2,-1}};
  float vertical, horizontal;
  int i, j, k, l;

  //create gray image
  if(input->gimage == NULL)
    genGrayFromColor(input);

  im->rows = input->rows;
  im->cols = input->cols;
  im->imagesize = input->imagesize;
  im->gimage = (unsigned char *)calloc(im->imagesize,sizeof(unsigned char));

  for(i=1; i<im->rows-1; i++) {
    for(j=1; j<im->cols-1; j++) {
      vertical = horizontal = 0.0;
      for(k=0; k<3; k++) {
	for(l=0; l<3; l++) {
	  vertical += gmap[k][l] * im->gimage[(i+k-1)*im->cols+(j+l-1)];
	  horizontal += gmap[l][k] * im->gimage[(i+k-1)*im->cols+(j+l-1)];
	}
      }
      vertical /= 4;
      horizontal /= 4;
      //average vertical and horizontal gradient
      im->gimage[i*im->cols+j] = (vertical + horizontal)/2;
    }
  }

  return im;
} // end gradientIm 

// This function thresholds the input image using the user-specified color
// as the threshold
// The input image should be in chromaticity space
Image *threshByExColor(Image *image, Pixel color) {

  Image *theImage = (Image *)malloc(sizeof(Image));
  int i;

  theImage->rows = image->rows;
  theImage->cols = image->cols;
  theImage->imagesize = image->imagesize;
  theImage->image = (Pixel *)malloc(sizeof(Pixel)*image->imagesize);
  theImage->color = true;

  for(i=0; i<theImage->imagesize; i++) {
    if(pow((double)(image->image[i].r - color.r),2)+
       pow((double)(image->image[i].g - color.g),2) < CHROM_RAD) {
      theImage->image[i] = (Pixel){255,255,255};
    }
    else {
      theImage->image[i] = (Pixel){0,0,0};
    }
  }

  return theImage;
} // end threshByExColor

//should be chromaticity image. its like above. only you define chrom_rad
void threshByPaddedColor(Image *theImage, Pixel color, int pad) {

  int i;

  for(i=0; i<theImage->imagesize; i++) {
    if(pow((double)(theImage->image[i].r - color.r),2)+
       pow((double)(theImage->image[i].g - color.g),2) < pad) {
      theImage->image[i] = (Pixel){255,255,255};
    }
    else {
      theImage->image[i] = (Pixel){0,0,0};
    }
  }

} // end threshByExColor

void colorThreshWithPad(Image *image, Pixel color,int pad) {

  Image *theImage = (Image *)malloc(sizeof(Image));
  int i;

  theImage->rows = image->rows;
  theImage->cols = image->cols;
  theImage->imagesize = image->imagesize;
  theImage->image = (Pixel *)malloc(sizeof(Pixel)*image->imagesize);
  theImage->color = true;

  for(i=0; i<theImage->imagesize; i++) {
    if(theImage->image[i].r>=color.r-pad&&
       theImage->image[i].r<=color.r+pad&&
       theImage->image[i].g>=color.g-pad&&
       theImage->image[i].g<=color.g+pad&&
       theImage->image[i].b>=color.b-pad&&
       theImage->image[i].b<=color.b+pad) {
      theImage->image[i] = (Pixel){255,255,255};
    }
    else {
      theImage->image[i] = (Pixel){0,0,0};
    }
  }
  free(image->image);
  image->image=theImage->image;
  free(theImage);
} // end threshByExColor


Image *subImage(Image *theImage,Box_t bbox){

  int i,j,k;

  Image *retval=(Image *)malloc(sizeof(Image));

  retval->rows=bbox[2]-bbox[0];//top-bottom
  retval->cols=bbox[3]-bbox[1];//right-left
  retval->imagesize=retval->rows*retval->cols;
  retval->color=theImage->color;
  retval->chroma=theImage->chroma;

  if(retval->color||retval->chroma){
    retval->image=(Pixel *)malloc(sizeof(Pixel)*retval->imagesize);
    for(i=bbox[0],k=0;i<bbox[2];i++){
      for(j=bbox[1];j<bbox[3];j++,k++){
	retval->image[k]=theImage->image[i*theImage->cols+j];
      }
    }

  }else{
    retval->gimage=(unsigned char *)malloc(sizeof(unsigned char)*retval->imagesize);
    for(i=bbox[0],k=0;i<bbox[2];i++){
      for(j=bbox[1];j<bbox[3];j++,k++){
	retval->gimage[k]=theImage->gimage[i*theImage->cols+j];
      }
    }

  }
  
  return retval;

}
